/*
 * Simple HTTPS POST
 *
 */ 
#include <stdio.h>
#include <curl/curl.h>
 
int main(int argc, char **argv)
{
  CURL *curl;
  CURLcode res;
  struct curl_slist *headers = NULL;

  char token[512];
  char url[512];
  char *json_str = "{ \
      \"enable\": true, \
      \"service\": \"abc\", \
      \"extPort\": { \
          \"start\": 8080, \
          \"end\": 8080 \
      }, \
      \"intPort\": { \
          \"start\": 80, \
          \"end\": 80 \
      }, \
      \"intIp\": \"192.168.5.123\", \
      \"protocol\": \"tcp\" \
    }";

  if(argc < 3) {
    printf("Usage: %s <token> <base url>\n", argv[0]);
    return 1;
  }
  sprintf(token, "mx-api-token: %s", argv[1]);
  sprintf(url, "%s/api/v1/network/portmapping", argv[2]);
 
  curl_global_init(CURL_GLOBAL_DEFAULT);
 
  curl = curl_easy_init();
  if(curl) {
    headers = curl_slist_append(headers, "Content-Type: application/json");
    headers = curl_slist_append(headers, token);
    curl_easy_setopt(curl, CURLOPT_URL, url);
    curl_easy_setopt(curl, CURLOPT_HTTPHEADER, headers); 

    /* Specify the POST data */ 
    curl_easy_setopt(curl, CURLOPT_POSTFIELDS, json_str);
 
    /* Skip the verification of the server's certificate. */
    curl_easy_setopt(curl, CURLOPT_SSL_VERIFYPEER, 0L);
 
    /* Skip to verify the certificate's name against host. */
    curl_easy_setopt(curl, CURLOPT_SSL_VERIFYHOST, 0L);
 
    /* Perform the request, res will get the return code */ 
    res = curl_easy_perform(curl);
    /* Check for errors */ 
    if(res != CURLE_OK)
      fprintf(stderr, "curl_easy_perform() failed: %s\n",
              curl_easy_strerror(res));
 
    /* always cleanup */ 
    curl_easy_cleanup(curl);
  }
 
  curl_global_cleanup();
 
  return 0;
}
